require "logger"
require "singleton"
require "active_support/core_ext/module/delegation"

require_relative "cache"

class Loggr
  include Singleton

  attr_reader :logger
  delegate :info, :warn, :error, to: :logger

  def initialize()
    @logger = Logger.new(output)
  end

  private

  def output()
    return STDOUT if ENV["GITOLEMY_VERBOSE"] == "true"
    Cache.ensure_directory(".gitolemy")
    File.open(File.join(".gitolemy", "out.log"), "w")
  end
end
