class Notifier
  def notify(url, commit, risk)
    return if ENV["GITOLEMY_SYNC"] == "true" || commit.nil?
    post(url, {
      status: risk <= 30 ? "success" : "failure",
      commit_id: commit.commit_id
    })
  end

  private

  def post(url, payload)
    uri = URI(url)
    request = Net::HTTP::Post.new(uri, {"Content-Type" => "application/json"})
    request.body = payload.to_json
    http = Net::HTTP.new(uri.hostname, uri.port)
    http.use_ssl = url.index("https://") == 0
    http.request(request)
  end
end
