class SourceTree

  def merge_collapse(commits)
    indexed_commits = commits.reduce({}, &method(:index_commits))

    graph = []
    head = commits.first
    while head
      graph << head
      commit_id = head.children.first
      head = indexed_commits[commit_id]
    end

    graph
  end

  private

  def index_commits(acc, commit)
    acc[commit.id] = commit
    acc
  end
end
