class VirtualFunction
  def initialize(function, file, lines)
    @name = function[:name]
    @file = file
    @start = function[:start]
    @end = function[:end]
    @lines = lines[(@start - 1)..@end]
  end

  def as_json()
    commits = {}
    issues = {}
    errors = {}
    bugs = {}
    score = 0

    @lines.each do |line|
      commits[line[:commit]] = true
      line[:revisions].each { |revision| commits[revision[:commit]] = true }
      line[:issues].each { |issue| issues[issue] = true }
      line[:errors].each { |error| errors[error] = true }
      line[:bugs].each { |bug| bugs[bug] = true }
      score += Line.score(line)
    end

    {
      name: @name,
      file: @file,
      start: @start,
      end: @end,
      bugs: bugs.keys,
      commits: commits.keys,
      issues: issues.keys,
      errors: errors.keys,
      score: score
    }
  end
end
